changed tmux conf

This commit is contained in:
pika 2025-04-01 19:35:08 +02:00
parent 52aa36edb9
commit fce4a85960
8 changed files with 378 additions and 209 deletions

2
.gitmodules vendored
View file

@ -7,7 +7,7 @@
url = https://git.k4li.de/dotfiles/zsh.git url = https://git.k4li.de/dotfiles/zsh.git
branch = main branch = main
[submodule "tmux"] [submodule "tmux"]
path = tmux path = dotfiles/.config/tmux
url = https://git.k4li.de/dotfiles/tmux.git url = https://git.k4li.de/dotfiles/tmux.git
branch = main branch = main
[submodule "dotfiles/.config/nvim"] [submodule "dotfiles/.config/nvim"]

1
dotfiles/.config/tmux/.gitignore vendored Normal file
View file

@ -0,0 +1 @@
.tmux/plugins/

4
dotfiles/.config/tmux/.gitmodules vendored Normal file
View file

@ -0,0 +1,4 @@
[submodule "Tmux-Plugin Manager"]
path = .tmux/plugins/tpm
url = https://github.com/tmux-plugins/tpm
branch = master

View file

@ -0,0 +1,6 @@
\.git
\.gitignore
\.gitmodules
^/README.*
^/LICENCE.*
^/COPYING

View file

@ -0,0 +1,157 @@
# ───────────────────────────────────────────────────────────────────────────
# General tmux Settings
# ───────────────────────────────────────────────────────────────────────────
# ─< Enable 256 color support for tmux >──────────────────────────────────────────────────
set-option -sa terminal-overrides ",xterm-256color*:Tc"
set -s escape-time 3
# ─< Enable mouse support (for scrolling, resizing, etc.) >───────────────────────────────
set -g mouse on
# Set the prefix key to C-Space instead of default C-b
unbind C-b
# ─< set the prefix to "C-Space" >────────────────────────────────────────────────────────
set -g prefix C-Space
bind C-Space send-prefix
bind h copy-mode
set -g visual-activity on
set -g visual-bell on
set -g status-keys vi
# ─< set v for starting selection in copy mode >──────────────────────────────────────────
bind -T copy-mode-vi v send -X begin-selection
# ─< Reload tmux configuration without restarting tmux >──────────────────────────────────
bind r source-file ~/.tmux.conf \; display-message "Config reloaded!"
# ─< Use C-h and C-l to switch between panes >────────────────────────────────────────────
bind -n C-h select-pane -L
bind -n C-l select-pane -R
bind -n C-f resize-pane -Z
# Ensure that when prefix is pressed, the mode indicator is shown
set -g mode-keys vi # Use vi keybindings in copy mode
set -g status-left-length 30 # Limit length of the left status line
set -g status-right-length 60 # Limit length of the right status line
# ─< Start windows and panes at index 1 instead of 0 >────────────────────────────────────
set -g base-index 1
set -g pane-base-index 1
set-window-option -g pane-base-index 1
set-option -g renumber-windows on
# set -g status-right '#{prefix_highlight} | 󰃭 %d.%m.%Y |  %H:%M'
# prompt to display when tmux prefix key is pressed
set -g @mode_indicator_prefix_prompt ' 󱙝 '
# prompt to display when tmux is in copy mode
set -g @mode_indicator_copy_prompt '  '
# prompt to display when tmux has synchronized panes
set -g @mode_indicator_sync_prompt '  '
# prompt to display when tmux is in normal mode
set -g @mode_indicator_empty_prompt ' 󰊠 '
# style values for prefix prompt
set -g @mode_indicator_prefix_mode_style 'bg=#fe8019,fg=#1d2021'
# style values for copy prompt
set -g @mode_indicator_copy_mode_style 'bg=cyan,fg=#1d2021'
# style values for sync prompt
set -g @mode_indicator_sync_mode_style 'bg=red,fg=#1d2021'
# style values for empty prompt
set -g @mode_indicator_empty_mode_style 'bg=#fabd2f,fg=#1d2021'
# ────────────────────────────────< theme - minimal config >────────────────────────────────
# set -g @plugin 'niksingh710/minimal-tmux-status'
# set -g @minimal-tmux-fg "#1d2021"
# set -g @minimal-tmux-bg "#fabd2f"
# set -g @minimal-tmux-indicator-str " 󰌽 $USER "
# set -g @minimal-tmux-indicator true
# set -g @minimal-tmux-status "bottom"
#
# # Enables or disables the left and right status bar
# set -g @minimal-tmux-right true
# set -g @minimal-tmux-left true
#
# # expanded icon (fullscreen icon)
# set -g @minimal-tmux-expanded-icon "󰊓 "
#
# # on all tabs (default is false)
# # false will make it visible for the current tab only
# set -g @minimal-tmux-show-expanded-icons-for-all-tabs true
#
# # To make the selection box rounded () or edged <>
# # Default is nothing, when set to true default is edged
# set -g @minimal-tmux-use-arrow false
# set -g @minimal-tmux-right-arrow "#[fg=#fabd2f]#[bg=#1d2021]"
# set -g @minimal-tmux-left-arrow "#[fg=#fabd2f]#[bg=#1d2021]"
#
# # Not recommended to change these values
# set -g @minimal-tmux-status-right "#[fg=#fabd2f]#[bg=#1d2021]#[fg=#1d2021]#[bg=#fabd2f]󰃭 %d.%m.%Y -  %H:%M#[fg=#fabd2f]#[bg=black]"
# # set -g @minimal-tmux-status-right "%d.%m.%Y"
# # set -g @minimal-tmux-status-left "refer to code"
#
# # To add or remove extra text in status bar
# set -g @minimal-tmux-status-right-extra "#[fg=#fb4934] #S"
# set -g @minimal-tmux-status-left-extra ""
#
# # If getting strings cut in left status or right
# # Here 20 is the length of the characters in the string
# set -g status-right-length 20
# set -g status-left-length 20
# ───────────────────────────────────< minimal --- end >─────────────────────────────────
# ────────────────────────────────< theme - gruvbox config >────────────────────────────────
# set -g @plugin 'egel/tmux-gruvbox' # Gruvbox theme for tmux
set -g @plugin 'https://git.k4li.de/mirrors/tmux-gruvbox'
set -g @tmux-gruvbox 'dark256' # Can be 'dark', 'dark256', 'light', 'light256'
set -g @tmux-gruvbox-left-status-a '#{tmux_mode_indicator}'
set -g @tmux-gruvbox-right-status-z "$USER@#h " # Hostname and tmux mode indicator
set -g @tmux-gruvbox-right-status-x '#[fg=yellow] %H:%M' # Time format 24H
set -g @tmux-gruvbox-right-status-y '󰃭 %d.%m.%Y' # Date format (e.g., 30.01.2024)
# ───────────────────────────────────< gruvbox --- end >─────────────────────────────────
# ──────────────────────────────< theme - gruvbox 2 - config >──────────────────────────────
# set -g @plugin 'l-lin/tmux-colorscheme'
# set -g @tmux-colorscheme-show-upload-speed true
# set -g @tmux-colorscheme-show-download-speed true
# set -g @tmux-colorscheme-show-prefix-highlight true
# set -g @tmux-colorscheme-show-battery true
# set -g @tmux-colorscheme-show-cpu true
# set -g @tmux-colorscheme-show-cpu-temp true
# set -g @tmux-colorscheme-show-ram true
# set -g @tmux-colorscheme "gruvbox-dark"
# ──────────────────────────────────< gruvbox 2 --- end >────────────────────────────────
# ───────────────────────────────────────────────────────────────────────────
# Key Bindings
# ───────────────────────────────────────────────────────────────────────────
# # ────────────────────────────────────< status configs >────────────────────────────────────
# ───────────────────────────────────────< plugins >─────────────────────────────────────
set -g @plugin 'nhdaly/tmux-better-mouse-mode'
set -g @plugin 'tmux-plugins/tmux-sensible' # Sensible tmux defaults
set -g @plugin 'tmux-plugins/tmux-yank' # Yank (copy-paste) support
set -g @plugin 'b0o/tmux-autoreload' # Auto-reload tmux config when updated
set -g @plugin 'MunifTanjim/tmux-mode-indicator'
# set -g @plugin 'tmux-plugins/tmux-prefix-highlight'
set -g @plugin 'tmux-plugins/tpm'
if "test ! -d ~/.tmux/plugins/tpm" \
"run 'git clone https://github.com/tmux-plugins/tpm ~/.tmux/plugins/tpm && ~/.tmux/plugins/tpm/bin/install_plugins'"
# Initialize TPM (Tmux Plugin Manager)
run '~/.tmux/plugins/tpm/tpm'

View file

@ -0,0 +1,2 @@
# tmux

View file

@ -9,284 +9,284 @@ BOLD='\033[1m'
NC='\033[0m' # No Color NC='\033[0m' # No Color
echo_error() { echo_error() {
printf "${BOLD}${RED}ERROR: ${NC}${RED}%s${NC}\n" "$1" >&2 printf "${BOLD}${RED}ERROR: ${NC}${RED}%s${NC}\n" "$1" >&2
} }
echo_info() { echo_info() {
printf "${BOLD}${CYAN}INFO: ${NC}${CYAN}%s${NC}\n" "$1" printf "${BOLD}${CYAN}INFO: ${NC}${CYAN}%s${NC}\n" "$1"
} }
echo_warning() { echo_warning() {
printf "${BOLD}${YELLOW}WARNING: ${NC}${YELLOW}%s${NC}\n" "$1" printf "${BOLD}${YELLOW}WARNING: ${NC}${YELLOW}%s${NC}\n" "$1"
} }
echo_note() { echo_note() {
printf "${BOLD}${LIGHT_GREEN}NOTE: ${NC}${LIGHT_GREEN}%s${NC}\n" "$1" printf "${BOLD}${LIGHT_GREEN}NOTE: ${NC}${LIGHT_GREEN}%s${NC}\n" "$1"
} }
# ─< Check if the given command exists silently >───────────────────────────────────────── # ─< Check if the given command exists silently >─────────────────────────────────────────
command_exists() { command_exists() {
command -v "$@" >/dev/null 2>&1 command -v "$@" >/dev/null 2>&1
} }
# ─< Check if the user is root and set sudo variable if necessary >─────────────────────── # ─< Check if the user is root and set sudo variable if necessary >───────────────────────
check_root() { check_root() {
if [ "$(id -u)" -ne 0 ]; then if [ "$(id -u)" -ne 0 ]; then
if command_exists sudo; then if command_exists sudo; then
echo_info "User is not root. Using sudo for privileged operations." echo_info "User is not root. Using sudo for privileged operations."
_sudo="sudo" _sudo="sudo"
else else
echo_error "No sudo found and you're not root! Can't install packages." echo_error "No sudo found and you're not root! Can't install packages."
return 1 return 1
fi fi
else else
echo_info "Root access confirmed." echo_info "Root access confirmed."
_sudo="" _sudo=""
fi fi
} }
# ─< Distribution detection and installation >──────────────────────────────────────── # ─< Distribution detection and installation >────────────────────────────────────────
get_packager() { get_packager() {
if [ -e /etc/os-release ]; then if [ -e /etc/os-release ]; then
echo_info "Detecting distribution..." echo_info "Detecting distribution..."
. /etc/os-release . /etc/os-release
ID=$(printf "%s" "$ID" | tr '[:upper:]' '[:lower:]') ID=$(printf "%s" "$ID" | tr '[:upper:]' '[:lower:]')
ID_LIKE=$(printf "%s" "$ID_LIKE" | tr '[:upper:]' '[:lower:]') ID_LIKE=$(printf "%s" "$ID_LIKE" | tr '[:upper:]' '[:lower:]')
case "$ID" in case "$ID" in
ubuntu | pop) _install() { $_sudo apt-get install --assume-yes "$@"; } ;; ubuntu | pop) _install() { $_sudo apt-get install --assume-yes "$@"; } ;;
debian) _install() { $_sudo apt-get install --assume-yes "$@"; } ;; debian) _install() { $_sudo apt-get install --assume-yes "$@"; } ;;
fedora) _install() { $_sudo dnf install -y "$@"; } ;; fedora) _install() { $_sudo dnf install -y "$@"; } ;;
alpine) _install() { $_sudo apk add "$@"; } ;; alpine) _install() { $_sudo apk add "$@"; } ;;
arch | archcraft | manjaro | garuda | endeavour) _install() { $_sudo pacman -S --noconfirm "$@"; } ;; arch | archcraft | manjaro | garuda | endeavour) _install() { $_sudo pacman -S --noconfirm "$@"; } ;;
opensuse*) _install() { $_sudo zypper in -y "$@"; } ;; opensuse*) _install() { $_sudo zypper in -y "$@"; } ;;
*) *)
if echo "$ID_LIKE" | grep -q "debian"; then if echo "$ID_LIKE" | grep -q "debian"; then
_install() { $_sudo apt-get install --assume-yes "$@"; } _install() { $_sudo apt-get install --assume-yes "$@"; }
elif echo "$ID_LIKE" | grep -q "ubuntu"; then elif echo "$ID_LIKE" | grep -q "ubuntu"; then
_install() { $_sudo apt-get install --assume-yes "$@"; } _install() { $_sudo apt-get install --assume-yes "$@"; }
elif echo "$ID_LIKE" | grep -q "arch"; then elif echo "$ID_LIKE" | grep -q "arch"; then
_install() { $_sudo pacman -S --noconfirm "$@"; } _install() { $_sudo pacman -S --noconfirm "$@"; }
elif echo "$ID_LIKE" | grep -q "fedora"; then elif echo "$ID_LIKE" | grep -q "fedora"; then
_install() { $_sudo dnf install -y "$@"; } _install() { $_sudo dnf install -y "$@"; }
elif echo "$ID_LIKE" | grep -q "suse"; then elif echo "$ID_LIKE" | grep -q "suse"; then
_install() { $_sudo zypper in -y "$@"; } _install() { $_sudo zypper in -y "$@"; }
else else
echo_error "Unsupported distribution: $ID" echo_error "Unsupported distribution: $ID"
return 1 return 1
fi fi
;; ;;
esac esac
else else
echo_error "Unable to detect distribution. /etc/os-release not found." echo_error "Unable to detect distribution. /etc/os-release not found."
return 1 return 1
fi fi
} }
silentexec() { silentexec() {
"$@" >/dev/null 2>&1 "$@" >/dev/null 2>&1
} }
__pre_stow__() { __pre_stow__() {
echo_note "__pre_stow__" echo_note "__pre_stow__"
conf="$HOME/.config" conf="$HOME/.config"
bak_dir="$HOME/.bak" bak_dir="$HOME/.bak"
dirs=( dirs=(
"btop" "btop"
"zsh" "zsh"
"yazi" "yazi"
"nvim" "tmux"
"ranger" "nvim"
"lf" "ranger"
) "lf"
)
if [ ! -d "$bak_dir" ]; then if [ ! -d "$bak_dir" ]; then
echo_info "backup dir created at $bak_dir" && echo_info "backup dir created at $bak_dir" &&
silentexec mkdir "$bak_dir" silentexec mkdir "$bak_dir"
else else
echo_info "Backup dir already present, clearing now" && echo_info "Backup dir already present, clearing now" &&
rm -rf "${bak_dir:?}/*" rm -rf "${bak_dir:?}/*"
fi fi
for _dirs in "${dirs[@]}"; do for _dirs in "${dirs[@]}"; do
if [ -d "$conf/$_dirs" ]; then if [ -d "$conf/$_dirs" ]; then
mv -f "$conf/$_dirs" "$bak_dir" mv -f "$conf/$_dirs" "$bak_dir"
fi fi
done done
h_files=( h_files=(
".zshrc" ".zshrc"
".zshenv" ".zshenv"
".tmux.conf" )
)
h_dirs=( h_dirs=(
".tmux" ".tmux"
".zsh" ".zsh"
) )
for _f in "${h_files[@]}"; do for _f in "${h_files[@]}"; do
if [ -f "$HOME/$_f" ]; then if [ -f "$HOME/$_f" ]; then
mv -f "$HOME/$_f" "$bak_dir" && echo_info "Moved $_f to $bak_dir" mv -f "$HOME/$_f" "$bak_dir" && echo_info "Moved $_f to $bak_dir"
fi fi
done done
for _d in "${h_dirs[@]}"; do for _d in "${h_dirs[@]}"; do
if [ -d "$HOME/$_d" ]; then if [ -d "$HOME/$_d" ]; then
mv -f "$HOME/$_d" "$bak_dir" && echo_info "Moved $_d to $bak_dir" mv -f "$HOME/$_d" "$bak_dir" && echo_info "Moved $_d to $bak_dir"
fi fi
done done
if [ -d "$HOME/.local/share/fastfetch/" ]; then if [ -d "$HOME/.local/share/fastfetch/" ]; then
mv -f "$HOME/.local/share/fastfetch" "$bak_dir" mv -f "$HOME/.local/share/fastfetch" "$bak_dir"
fi fi
} }
askThings() { askThings() {
# echo_info "Choose a menu - [r]ofi || [t]ofi" # echo_info "Choose a menu - [r]ofi || [t]ofi"
# read -r askMenu </dev/tty # read -r askMenu </dev/tty
[ ! -d "./dotfiles/.config/yazi" ] && [ ! -d "./dotfiles/.config/lf" ] && [ ! -d "./dotfiles/.config/ranger" ] && { [ ! -d "./dotfiles/.config/yazi" ] && [ ! -d "./dotfiles/.config/lf" ] && [ ! -d "./dotfiles/.config/ranger" ] && {
echo_info "Choose a cli filemanager - [y]azi || [r]anger || [l]f" echo_info "Choose a cli filemanager - [y]azi || [r]anger || [l]f"
read -r askFilemgr </dev/tty read -r askFilemgr </dev/tty
} }
# echo_info "Choose a bar provider - [w]aybar || [g]Bar || [h]yprpanel" # echo_info "Choose a bar provider - [w]aybar || [g]Bar || [h]yprpanel"
# read -r askBar </dev/tty # read -r askBar </dev/tty
# #
# echo_info "Choose a Terminal config (.)[G]hostty, [K]itty, [A]lacritty(.)" # echo_info "Choose a Terminal config (.)[G]hostty, [K]itty, [A]lacritty(.)"
# read -r askTerminal </dev/tty # read -r askTerminal </dev/tty
echo_info "Do you also want to install optional packages? (y/n)" echo_info "Do you also want to install optional packages? (y/n)"
read -r askOptional </dev/tty read -r askOptional </dev/tty
case "$askOptional" in case "$askOptional" in
[yY]) __optional__="true" ;; [yY]) __optional__="true" ;;
[nN]) __optional__="false" ;; [nN]) __optional__="false" ;;
esac esac
} }
cloneDots() { cloneDots() {
choise="$1" choise="$1"
if command_exists git; then if command_exists git; then
[ -d ./dotfiles ] && [ -d ./dotfiles ] &&
[ ! -d "./dotfiles/${choise}" ] && [ ! -d "./dotfiles/${choise}" ] &&
git clone --depth=1 "https://git.k4li.de/dotfiles/${choise}.git" "./dotfiles/.config/${choise}" git clone --depth=1 "https://git.k4li.de/dotfiles/${choise}.git" "./dotfiles/.config/${choise}"
else else
echo_error "Git was not found" echo_error "Git was not found"
fi fi
} }
__validate__() { __validate__() {
if askThings; then if askThings; then
case "$askFilemgr" in case "$askFilemgr" in
[yY] | yazi) cloneDots "yazi" ;; [yY] | yazi) cloneDots "yazi" ;;
[rR] | ranger) cloneDots "ranger" ;; [rR] | ranger) cloneDots "ranger" ;;
[lL] | lf) cloneDots "lf" ;; [lL] | lf) cloneDots "lf" ;;
esac esac
else else
echo_error "Something went terribly wrong" echo_error "Something went terribly wrong"
exit 1 exit 1
fi fi
# if [ ! -d "$HOME/.config/nvim" ]; then # if [ ! -d "$HOME/.config/nvim" ]; then
# echo_note "There was no nvim config found, do you want to clone the pika nvim? (y/n)" # echo_note "There was no nvim config found, do you want to clone the pika nvim? (y/n)"
# read -r _neovim </dev/tty # read -r _neovim </dev/tty
# case "$_neovim" in # case "$_neovim" in
# [yY]) # [yY])
# git clone --recursive --depth=1 https://git.k4li.de/dotfiles/nvim.git "$HOME/.config/nvim" # git clone --recursive --depth=1 https://git.k4li.de/dotfiles/nvim.git "$HOME/.config/nvim"
# ;; # ;;
# esac # esac
# fi # fi
} }
__dep__() { __dep__() {
_depss=( _depss=(
"stow" "stow"
"btop" "btop"
"entr" "entr"
"unzip" "unzip"
"zip" "zip"
"fzf" "fzf"
"tmux" "tmux"
"rsync" "rsync"
"zoxide" "zoxide"
) )
for hyprdots_dependency in "${_depss[@]}"; do for hyprdots_dependency in "${_depss[@]}"; do
if ! command_exists "$hyprdots_dependency"; then if ! command_exists "$hyprdots_dependency"; then
echo_note "--- installing $hyprdots_dependency ---" echo_note "--- installing $hyprdots_dependency ---"
_install "$hyprdots_dependency" _install "$hyprdots_dependency"
else else
echo_info "$hyprdots_dependency is already installed" echo_info "$hyprdots_dependency is already installed"
fi fi
done done
} }
pkg_optional() { pkg_optional() {
_ops=( _ops=(
"cowsay" "cowsay"
"cmatrix" "cmatrix"
"trash-cli" "trash-cli"
) )
case "$_ops" in case "$_ops" in
Y | y) Y | y)
for _o_ in "${_ops[@]}"; do for _o_ in "${_ops[@]}"; do
if command_exists "$_o_"; then if command_exists "$_o_"; then
echo_note "$_o_ - is already installed" echo_note "$_o_ - is already installed"
else else
echo_info "Installing $_o_" echo_info "Installing $_o_"
_install "$_o_" _install "$_o_"
fi fi
done done
;; ;;
*) *)
echo default echo default
;; ;;
esac esac
} }
__stow__() { __stow__() {
stow --verbose --target="$HOME" --defer=.gitmodules --restow */ stow --verbose --target="$HOME" --defer=.gitmodules --restow */
} }
main() { main() {
check_root check_root
get_packager get_packager
__validate__ __validate__
__dep__ __dep__
if ! command_exists stow; then if ! command_exists stow; then
echo_error "we couldn't find stow on the machine, do you want us to install it? (y/n): " echo_error "we couldn't find stow on the machine, do you want us to install it? (y/n): "
read -r ask_stow read -r ask_stow
case "$ask_stow" in case "$ask_stow" in
Y | y) Y | y)
_install stow _install stow
;; ;;
*) *)
echo_error "You cannot proceed without installing stow! Please install manually" echo_error "You cannot proceed without installing stow! Please install manually"
exit 1 exit 1
;; ;;
esac esac
else else
echo_info "stow was found, going on to prepare to stow your config" echo_info "stow was found, going on to prepare to stow your config"
sleep 0.3 sleep 0.3
fi fi
__pre_stow__ __pre_stow__
__stow__ __stow__
sleep 2 sleep 2
[ "$__optional__" == 'true' ] && [ "$__optional__" == 'true' ] &&
pkg_optional pkg_optional
# __monitors__ # __monitors__
# echo_note "found resolution ${res}" # echo_note "found resolution ${res}"
} }
main main

1
tmux

@ -1 +0,0 @@
Subproject commit 25036ec9860880e0e85b3f8d69bfe43ad03f05c9